# Coveo QuerySuggestPreview Component (CoveoQuerySuggestPreview)

This component renders previews of the top query results matching the currently focused query suggestion in the search box.

As such, this component only works when the search interface can provide Coveo Machine Learning query suggestions.

This component should be initialized on a `div` which can be nested anywhere inside the root element of your search interface.

See Rendering Query Suggestion Result Previews.

Available since

  December 2019 Release (v2.7610)

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- executeQueryDelay
- numberOfPreviewResults
- resultTemplate

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### executeQueryDelay

executeQueryDelay: number

- Defined in ui/QuerySuggestPreview/QuerySuggestPreview.ts :82

The amount of focus time (in milliseconds) required on a query suggestion before requesting a preview of its top results.

Default

  `200`

Markup configuration example(s) :

    data-execute-query-delay='10'

### numberOfPreviewResults

numberOfPreviewResults: number

- Defined in ui/QuerySuggestPreview/QuerySuggestPreview.ts :74

The maximum number of query results to render in the preview.

Minimum

  `1`

Maximum

  `6`

Default

  `4`

Markup configuration example(s) :

    data-number-of-preview-results='10'

### resultTemplate

resultTemplate: Template

- Defined in ui/QuerySuggestPreview/QuerySuggestPreview.ts :70

The HTML `id` attribute value, or CSS selector of the previously registered result template to apply when rendering the query suggestion result previews.

Examples

- Specifying the `id` attribute of the target result template:

      <div class="CoveoQuerySuggestPreview" data-result-template-id="myTemplateId"></div>

- Specifying an equivalent CSS selector:

      <div class="CoveoQuerySuggestPreview" data-result-template-selector="#myTemplateId"></div>

If you specify no previously registered template through this option, the component uses its default template.

## Constructors

### constructor

- new QuerySuggestPreview(element: HTMLElement, options?: IQuerySuggestPreview, bindings?: IComponentBindings): QuerySuggestPreview

- Overwrites Component.constructor

  - Defined in ui/QuerySuggestPreview/QuerySuggestPreview.ts :83

  Creates a new QuerySuggestPreview component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IQuerySuggestPreview

    The options for the QuerySuggestPreview component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns QuerySuggestPreview

### Implements

- IComponentBindings